<script>
    import MailInstance from './MailInstance'

    export default {
        name: "mail-list",
        components: {
            MailInstance
        },
        props: {
            inbox: {
                required: true,
                type: Object
            },
            active_mail_vector: {
                required: true,
                type: Array
                // an vector of 2 items first is inboxes id,
                // secound is index of the instance of the mails property of inbox
            }
        },
        computed: {
            sortMails() {
                const draft =  this.inbox.mails.map((mail, real_index) => ({...mail, real_index}))
                return draft.sort((a, b) => b.received_at - a.received_at)
            }
        },
        methods: {
            emitActiveMail(mail_index) {
                const box = this.inbox
                const mail_vector = [box.id, mail_index]
                this.$emit('mail_opened', mail_vector)
            },
            isActive(index) {
                const a = this.active_mail_vector
                return a[0] === this.inbox.id && a[1] === index
            }
        }
    }
</script>

<template>
    <div>
        <div
            :key="i"
            @click="emitActiveMail(mail.real_index)" v-for="(mail, i) in sortMails"
        >
            <mail-instance
                    :mail="mail"
                    v-bind:class="{ active: isActive(mail.real_index) }"
            />
        </div>
    </div>
</template>

<style scoped>

</style>